///////////////////////////////////////////////////////////////////////////////
// StringClob.java -- implements java.sql.Clob

package samples;

import java.sql.*;
import java.io.*;

public class StringClob implements java.sql.Clob
{
    private String s;
    
    public StringClob( String data ) throws SQLException {
        if( data == null )
            throw new SQLException( "[StringClob] invalid parameter: null" );
            
        s = data;   
    }
    
    public java.io.InputStream getAsciiStream() throws SQLException
    {
		try{
			return new java.io.ByteArrayInputStream( s.getBytes("ISO8859_1"));
		}catch(Exception e){
			return new java.io.ByteArrayInputStream( s.getBytes());
		}
    }

    public java.io.Reader getCharacterStream() throws SQLException
    {
        return new StringReader( s );
    }

    public String getSubString( long pos, int length ) throws SQLException
    {
        return s.substring( (int)pos - 1, (int)pos + length - 1 );
    }

    public long length() throws SQLException
    {
        return s.length();
    }

    public long position( String searchstr, long start ) throws SQLException
    {
        return s.indexOf( searchstr, (int)start - 1 );
    }

    public long position( Clob searchstr, long start ) throws SQLException
    {
        return position( searchstr.getSubString( 1, (int)searchstr.length() ), start );
    }
    
    //////////////////////////////////////////////
    // JDBC 3.0 methods, currently unimplemented
    
    public java.io.OutputStream setAsciiStream(long pos) throws SQLException
    {
        throw new SQLException( "method not implemented" );
    }

    public java.io.Writer setCharacterStream(long pos) throws SQLException
    {
        throw new SQLException( "method not implemented" );
    }

    public int setString(long pos, java.lang.String str) throws SQLException
    {
        throw new SQLException( "method not implemented" );
    }
    
    public int setString(long pos, java.lang.String str, int offset, int len)  throws SQLException
    {
        throw new SQLException( "method not implemented" );
    }
  
    public void truncate(long len) throws SQLException
    {
        throw new SQLException( "method not implemented" );
    }
    
}
