/*
i-net software provides programming examples for illustration only, without warranty 
either expressed or implied, including, but not limited to, the implied warranties 
of merchantability and/or fitness for a particular purpose. This programming example 
assumes that you are familiar with the programming language being demonstrated and 
the tools used to create and debug procedures. i-net software support professionals 
can help explain the functionality of a particular procedure, but they will not modify 
these examples to provide added functionality or construct procedures to meet your 
specific needs.
 i-net software 2001

  This sample demonstrate how to use the PooledConnection of the driver.
  This can you use if you want build your own pool manager.

*/

package samples;

import java.sql.*;                  // JDBC package
import javax.sql.*;                 // extended JDBC package

public class WithPoolDataSource
{

    public static void main(String[] argv){
        String login    = "scott";	   			// use your login here
        String password = "tiger";	   			// use your password here

	    try {
		    DriverManager.setLogStream(System.out); // to create more info 
							                        // for technical support
    			

    		// create a DataSource
            com.inet.ora.PDataSource pds = new com.inet.ora.PDataSource();
            pds.setServerName( "localHost" );
            pds.setServiceName( "xxx" );
            pds.setPort( "1521" );
            pds.setUser( login );
            pds.setPassword( password );
            pds.setLoginTimeout( 10 );
            pds.setDescription( "A Test Data Source" );
            ConnectionPoolDataSource ds = pds;


		    //open a PooledConnection to the database
		    PooledConnection pConn = ds.getPooledConnection(login,password);
		    
		    // request the Connection
		    Connection connection = pConn.getConnection();
		    
		    //to get the driver version
	        DatabaseMetaData conMD = connection.getMetaData();
	        System.out.println("Driver Name:   \t" + conMD.getDriverName());
	        System.out.println("Driver Version:\t" + conMD.getDriverVersion());

		    // return the connection
		    connection.close();

		    // request the Connection
		    connection = pConn.getConnection();

		    //create a statement
		    Statement st = connection.createStatement();

		    //execute a query
		    ResultSet rs = st.executeQuery("SELECT * FROM users");

		    // read the data and put it to the console
		    while (rs.next()){
			    for(int j=1; j<=rs.getMetaData().getColumnCount(); j++){
				    System.out.print( rs.getObject(j)+"\t");
			    }
			    System.out.println();    
		    }

    		
		    //close the objects
		    st.close();
		    connection.close();

		    // close the PooledConnection to the database
		    pConn.close();
		    
	    } catch(Exception e) {
		    e.printStackTrace();
	    }
    }
    

}